<template>
  <div class="flex flex-row">
    <info-cell>{{ lodge.id }}</info-cell>
    <info-cell>{{ lodge.name }}</info-cell>
    <info-cell>{{ lodge.country }}</info-cell>
    <div class="flex items-center">
      <router-link :to="{ name: 'LodgeMasons', params: { id: lodge.id } }">
        <view-button title="View events of this lodge" />
      </router-link>
      <router-link :to="{ name: 'EditLodge', params: { id: lodge.id } }">
        <edit-button title="Edit lodge info" />
      </router-link>
      <remove-button @click="deleteLodge" title="Remove lodge from database" />
    </div>
  </div>
</template>

<script>
import InfoCell from '@/components/InfoCell.vue';
import EditButton from '@/components/EditButton.vue';
import ViewButton from '@/components/ViewButton.vue';
import RemoveButton from '@/components/RemoveButton.vue';
import { mapGetters, mapMutations } from 'vuex';
import axiosClient from '@/axiosClient';

export default {
  props: ['id'],
  components: {
    InfoCell,
    EditButton,
    ViewButton,
    RemoveButton,
  },
  methods: {
    ...mapMutations(['removeLodge']),
    deleteLodge() {
      axiosClient.delete(`/lodges/${this.id}`)
        .then(() => {
          this.removeLodge(this.id)
        })
    }
  },
  computed: {
    lodge() {
      return this.lodgeById(this.id)
    },
    ...mapGetters({
      lodgeById: "getLodge"
    })
  }
}
</script>